;  : tasm 4.1, tlink, rtm.exe. dpmi16bi.ovl
include  debug.mac	;   
	.386p		;   386
;**********************************************************************
;     
    descr struc
	limit    dw     0	;,  0..15
        base_1   dw     0	;,  0..15
        base_m   db     0	;,  16..23
        attr_1   db     0	;  1
        attr_2   db     0	;  2
        base_h   db     0	;,  24..31 
        descr    ends
;    
    trap  struc
        offs_1          dw      0	; 
        sel             dw      16	;  
        rsrv            db      0	;
        attr            db      8fh	;  ( )
        offs_h          dw      0	; 
        trap            ends
;      0
  oldstk      struc
    oldip          dw        0,0	;eip 
    oldcs          dw        0,0	;cs 
    oldfl          dw        0,0	;eflags
    oldsp          dw        0,0	;esp 
    oldss          dw        0,0	;ss 
    oldes          dw        0,0	;  es
    oldds          dw        0,0	;  ds
    oldfs          dw        0,0	;  fs
    oldgs          dw        0,0	;c  gs
    oldstk   ends
;********************************************************************
;                  
;********************************************************************
    data segment use16	; 16-     16- , 
			;     

    	 	; GDT     

     gdt_null descr    <>                     ;0   -
     gdt_data descr    <data_size-1,,,92h>    ;8 -   
     gdt_code descr    <code_size-1,,,9ah>    ;16 -  
     gdt_stack descr   <stk386-1,0,0,92h>     ;24 -  
     gdt_screen descr  <4095,8000h,0bh,0f2h>  ;32  3-   3 
     gdt_tss_0 descr   <103,0,0,89h>          ;40 - TSS 0 
     gdt_tss_1 descr   <103,0,0,89h>          ;48 - TSS 1
     gdt_tss_2 descr   <103,0,0,89h>	      ;56    - TSS 2
     gdt_ldt_1 descr   <ldt_1_size-1,,,82h>   ;64   - LDT 1
     gdt_ldt_2 descr   <ldt_2_size-1,,,82h>   ;72   - LDT 2
     gdt_tss_v86 descr <tss_86_size-1,0,0,89h>;80 - TSS V86
     gdt_00    descr   <03ffh,0,0,92h>        ; 88-  
                                              ;       
     gdt_code_86 descr     <0ffffh,,,92h>     ;96--   V86
     gdt_stk_86 descr     <0ffffh,,,92h>      ;104 -   V86
     gdt_size=$-gdt_null		      ; GDT

;  IDT -       ,    
; 		     

     idt label word			  ; IDT
     trap      10       dup (<dummy_exc>) ;  0  9
     trap      <exc_0ah>		  ;10-  TSS
     trap      <exc_0bh>		  ;11-  
     trap      <exc_0ch>		  ;12-    
     trap      <handler>		  ;13- 
     trap      <exc_0eh>		  ;14- 
     trap     18       dup (<dummy_exc>)  ;17 +1-
     trap          <new_09h,,,8eh>	  ;  
     idt_size=$-idt			  ; IDT


     pdescr     dq      0 		  ;
     mes        db  5,5,5,'    ' ,5,5,5,'$'
     tblhex     db  '0123456789abcdef'	;  2->16
     string     db  '**** ****_**** ****_**** ****_**** ****'
     len=$-string	;    
     mes0	db  5,5,5,'     0 ',5,5,5
     mes0_len=$-mes0	;  
     tss_0       dw     104  dup (0); TSS  ,   
     tss_1       dw     104  dup (0); -104 ,   TSS 
     tss_2       dw     104  dup (0);  ,  
     tss_v86     dw     104  dup (0);  DW
     iomap	db	13000 dup (0);   - 
     ioend	dw	0ffffh      ;    , ..  
     tss_86_size=$-tss_v86  ;        
		       ;..     (INT 10h)
     home_sel    dw     home,16 ;     
; 13 ,    ,     
;     2- 

	; LDT-     

;          LDT,   
;  LDTR  ,      
;  .      ,   .
; LDT-1
      ldt_1 label word
      ldt_data_1 descr  <data_1_size-1,,,0f2h>;4 (LDT) +3 ()
      ldt_code_1 descr  <code_1_size-1,,,0fah>;12 (LDT)+3 ()
      ldt_stk_1  descr  <255,,,0f2h,,>;20+3-   - 96h
      ldt_1_size=$-ldt_1
; LDT-2
      ldt_2 label word
      ldt_data_2  descr  <data_2_size-1,,,0f2h>;4+3
      ldt_code_2  descr  <code_2_size-1,,,0fah>;12+3
      ldt_stk_2   descr  <255,,,0f2h,,>;20+3
      ldt_2_size=$-ldt_2
      data_size=$-gdt_null
      data ends
;********************************************************************* 
;                  ()  
;*********************************************************************
   text segment 'code' use16
             assume cs:text,ds:data ;   
           begin  label word
;  
;***************************************
    exc_0ah  proc; 
	     pop eax ;   
	     pop eax ;  IP ,  
             mov si,offset string+5;  si- +5
             debug;          AX   string
             mov ax,0ah ;    AX  
	     jmp home;    
    exc_0ah endp;      
;***************************************
        exc_0bh  proc
	     pop eax
	     pop eax
             mov si,offset string+5
             debug
             mov ax,0bh
             jmp home
    exc_0bh endp
;***************************************
        exc_0ch  proc
             pop eax
             pop eax ;????
             mov si,offset string+5
             debug
             mov ax,0ch
             jmp home
    exc_0ch endp		 
;***************************************
;  
;****  13  +   V86 **********
handler proc
	push ax		;  AX
	mov ax,8	;  DS  FS   
	mov ds,ax	;   
	mov fs,ax	; 
	mov ax,32	; ES- 
	mov es,ax	;
	pop ax		;  AX
	cmp sp,stk0-40	; ,      
	jne no_code	; ,  
	add sp,4	; ,     
no_code:
	pushad		;  
	mov bp,sp	;  BP    0 
	add bp,32	;   pushad
	mov eax,dword ptr [bp].oldfl	;  EFLAGS 
	bt eax,17	;    17-  
	jc vm_ok	; ,      
;	mov  ax,0faceh	; ,    ,  
;	jmp dword ptr home_sel ;    string 
jmp dword ptr cs:trs	;      ,    2
vm_ok:
	mov ax,96 	;     V86  
	mov ds,ax 	;   ,    INT
	mov si,[bp].oldip	;si=ip V86   lodsb 
	cld		;    
	lodsb		;     ds:si
	cmp al,0cdh	;   INT ?
	je beginxxx	; ,  
	jmp dword ptr cs:trs ; ,    2

beginxxx:
	lodsb 		;    INT
	mov [bp].oldip,si;     INT  
	sub ah,ah 	;  AH
	shl ax,2	;       4
	mov bx,ax	;  BX 
	mov si,[bp].oldsp ;  si sp   V86
	sub si,6	;  6    
	mov [bp].oldsp,si ;     sp   
			;  0
	mov ax,104	;     V86  
	mov ds,ax	;  
	mov cx,[bp].oldip ; IP    V86
	mov dx,[bp].oldcs ; CS    V86
	mov di,[bp].oldfl ; EFLAGS   
	mov [si],cx	; IP     V86
	mov [si+2],dx	;      
	mov [si+4],di	;  (IP, CS, EFLAGS)
	and di,0fdffh	;  IF,  INT
	mov ax,88	;      
	mov ds,ax	; 
	mov ax,[bx]	;    
	mov cx,[bx+2]	;    
	mov [bp].oldfl,di ;    
	mov [bp].oldip,ax ;  DOS
	mov [bp].oldcs,cx ;    0
	popad		;  
	db 66h		;  32-  
	iret		; "" ()  DOS
trs dw 0,56		;    2
handler endp
;********************************************************************
;***************************************
       exc_0eh  proc
             pop eax
             pop eax ;????
             mov si,offset string+5
             debug
             mov ax,0eh
             jmp home
    exc_0eh endp
;***************************************
    dummy_exc  proc
             pop eax
             pop eax ;????
             mov si,offset string+5
             debug
             mov ax,1111h
             jmp home
    dummy_exc endp
;***************************************

;****      *******

    new_09h   proc
              push      ax	;   
              push      dx	; 
              in        al,60h	;  -
              mov       dl,al	;   
              in        al,61h	;    
              or        al,80h	;    
              out       61h,al	;     
              and       al,7fh	;   
              out       61h,al	;   - 
              mov       al,20h	;  EOI   
              out       20h,al	; IRQ    
              cmp       dl,0bh	;  "0" ? 
              je        tsk0	; ,    0
              cmp       dl,2	;  "1" ?	
              je        tsk1	; ,    1
              cmp       dl,3	;  "2" ?
              je        tsk2	; ,    2
              cmp       dl,2fh	;  "v" ?
              je        tsk86	; ,    V86
		cmp   dl,44h	;  F10 ?
		je  exit	; ,    
              jmp       out_1	;  ,     
exit:
            mov   al,0feh 	;  
            out   64h,al	;
            hlt			;
          tsk0:  str    ax	;  TR
                 cmp    ax,40	;     TR   0
                 je     out_1	; ,   0, 
                 pop    dx	; ,    ,  
                 pop    ax	;    
                 jmp   dword   ptr cs:  t0_addr ; 
                 jmp   out_09h	;      
          tsk1:  str   ax
                 cmp   ax,48
                 je    out_1      		 
                 pop   dx
                 pop   ax
		
                 jmp   dword  ptr  cs:  t1_addr
                 jmp   out_09h;
          tsk2:  str   ax
                 cmp   ax,56
                 je    out_1
                 pop   dx
                 pop   ax
                 jmp   dword  ptr cs:      t2_addr
                 jmp   out_09h
          tsk86:
		 str   ax
                 cmp   ax,80
                 je    out_1
                 pop   dx
                 pop   ax
                 jmp   dword  ptr cs:  t86_addr

          out_09h:
		   db  66h ;  32-  
                   iret	   ;   
           out_1: pop    dx ; -  ,  
                  pop    ax ;      
                  jmp    out_09h
          t0_addr   dw    0,40	;     
          t1_addr   dw    0,48
          t2_addr   dw    0,56
          t86_addr  dw    0,80
               new_09h  endp

;    0,      

    main proc

; ********************************************************************
; 	     - 
; 		 ,  , 
; ********************************************************************
           xor  eax,eax	;  EAX
           mov  ax,data	;  ax-   
           mov  ds,ax	;      
                        ;seg data
           shl  eax,4	;       4 
			;    16
           mov  ebp,eax	;   EBP  
           mov  bx,offset gdt_data ;    
           mov  [bx].base_1,ax	;    
           rol  eax,16		;     
           mov  [bx].base_m,al	;    
                        ;seg command
;  
           xor   eax,eax
           mov   ax,cs
           shl   eax,4
           mov   bx,offset  gdt_code
           mov   [bx].base_1,ax
           rol   eax,16
           mov   [bx].base_m,al
                        ;seg stack
           xor    eax,eax
           mov    ax,ss
           shl    eax,4
           mov    bx,offset  gdt_stack
           mov    [bx].base_1,ax
           rol    eax,16
           mov    [bx].base_m,al
                          ;seg tss_0
           mov    eax,ebp;  EAX   data
           add    ax,offset tss_0;      data
           mov    bx,offset gdt_tss_0
           mov    [bx].base_1,ax
           rol    eax,16
           mov    [bx].base_m,al
                         ;seg tss_1
           mov  eax,ebp
           add  ax,offset  tss_1
           mov  bx,offset  gdt_tss_1
           mov  [bx].base_1,ax
           rol  eax,16
           mov  [bx].base_m,al
                     ; gdt tss2
           mov  eax,ebp
           add  ax,offset tss_2
           mov bx,offset  gdt_tss_2
           mov [bx].base_1,ax
           rol eax,16
           mov [bx].base_m,al
           ;  gdt_ldt_1
           mov  eax,ebp
           add  ax,offset  ldt_1
           mov  bx,offset  gdt_ldt_1
           mov  [bx].base_1,ax
           rol  eax,16
           mov  [bx].base_m,al
           ;  gdt_ldt_2
           mov  eax,ebp
           add  ax,offset  ldt_2
           mov  bx,offset  gdt_ldt_2
           mov  [bx].base_1,ax
           rol  eax,16
           mov  [bx].base_m,al
;      LDT    
           ; data_1 in ldt_1
           xor  eax,eax
           mov  ax,data_1
           shl  eax,4
           mov  bx,offset ldt_data_1
           mov  [bx].base_1,ax
           rol  eax,16
           mov  [bx].base_m,al
           ; text_1 in ldt_1
           xor  eax,eax
           mov  ax,text_1
           shl  eax,4
           mov  bx,offset ldt_code_1
           mov  [bx].base_1,ax
           rol  eax,16
           mov  [bx].base_m,al
             ;  stk in ldt_1
           xor  eax,eax
           mov  ax,stk_1
           shl  eax,4
           mov  bx,offset ldt_stk_1
           mov  [bx].base_1,ax
           rol  eax,16
           mov  [bx].base_m,al
           ; data text  stk in ldt_2
           ; data_2 in ldt_2
           xor  eax,eax
           mov  ax,data_2
           shl  eax,4
           mov  bx,offset ldt_data_2
           mov  [bx].base_1,ax
           rol  eax,16
           mov  [bx].base_m,al
           ; text_2 in ldt_2
           xor  eax,eax
           mov  ax,text_2
           shl  eax,4
           mov  bx,offset ldt_code_2
           mov  [bx].base_1,ax
           rol  eax,16
           mov  [bx].base_m,al
             ;  stk in ldt_2
           xor  eax,eax
           mov  ax,stk_2
           shl  eax,4
           mov  bx,offset ldt_stk_2
           mov  [bx].base_1,ax
           rol  eax,16
           mov  [bx].base_m,al
           ;V86
           mov  eax,ebp
           add  ax,offset tss_v86
           mov bx,offset  gdt_tss_v86
           mov [bx].base_1,ax
           rol eax,16
           mov [bx].base_m,al
;*******************************************************
  
;        V86 
;    - 
           xor  eax,eax 
           mov  ax,code_86
           shl  eax,4
           mov  bx,offset gdt_code_86
           mov  [bx].base_1,ax
           rol  eax,16
           mov  [bx].base_m,al

           xor  eax,eax
           mov  ax,stk_86
           shl  eax,4
           mov  bx,offset gdt_stk_86
           mov  [bx].base_1,ax
           rol  eax,16
           mov  [bx].base_m,al

;*******************************************************


           ;   
           mov   dword ptr pdescr+2,ebp ;    
				;   GDT
           mov   word  ptr pdescr,gdt_size-1 ;  GDT
           lgdt  pdescr ;   GDTR

           ;***init  task's fields

           mov       tss_1+4ch,15	;cs  1: 12-LDT+3-=15
           mov       tss_1+20h,offset task1	;    
           mov       tss_1+50h,23	;  
           mov       tss_1+38h,256	;sp-  
           mov       tss_1+54h,07	;  
           mov       tss_1+48h,35	;

           sti				;   IF-
           pushfd			;,   
           pop eax			;  
           mov dword ptr tss_1+24h,eax  ;    
			;      3200h
           mov       tss_1+60h,64	; LDT  
	   mov	     tss_1+4,256	;** ESP0 **!!!!  !!!!!
	   mov	     tss_1+8,24		; SS0
           ; tss_2
           mov       tss_2+4ch,15;      cs
           mov       tss_2+20h,offset task2
           mov       tss_2+50h,23
           mov       tss_2+38h,256
           mov       tss_2+54h,07
           mov       tss_2+48h,35
           mov dword ptr tss_2+24h,eax
           mov       tss_2+60h,72
	   mov       tss_2+4,768; !!!!!!  !!!!!
	   mov       tss_2+8,24
           ;tss_v86
; TSS V86     , 
;    
	   mov			ax,code_86 ;  
	   mov	     tss_v86+4ch,ax  ;  
           mov       tss_v86+20h,offset  task_v86 ;    
           mov			ax,stk_86 ; 
	   mov	     tss_v86+50h,ax
	   mov  		ax,stk86
           mov       tss_v86+38h,ax
           mov			ax,data_86
	   mov	     tss_v86+54h,ax
           mov       tss_v86+48h,0b800h
           mov dword ptr  tss_v86+24h,23200h;   -
		;  VM, 3- ,  IF  
           mov       tss_v86+8,24
	   mov  		ax,stk0
           mov       tss_v86+4,512;!!!!!!  !!!!!!
       	   mov	     tss_v86+66h,68h;tss_86_size;104
	   mov     tss_0+60h,0

;*******************     ************************
           cli

           mov  al,0fh ;    
           out  70h,al ;    (CMOS) -
           mov  al,05h ;5-     		       
           out  71h,al ; 40:67   
           mov  ax,40h ;  es    BIOS
           mov  es,ax  ; 
           mov  word ptr es:[67h],offset return ;  
           mov  word ptr es:[69h],cs ;   

;******      *****************
           mov  dx,20h ; 
           mov  al,11h ;  3  4
           out  dx,al  ;   20h 1 (ICW1)
           inc  dx     ;    21h
           mov  al,20h ; 2-  20h=32
           out  dx,al  ; 
           mov  al,4   ; 3-     2
           out  dx,al  ; 
           mov  al,1   ; 4-  8086 (Pentium)
           out  dx,al  ;   EOI
           mov  al,0fdh ; -  
           out  dx,al  ; 
           mov  dx,0a1h ;   
           mov  al,0ffh ;   
           out  dx,al  ; 

;     IDTR
           mov word ptr pdescr,idt_size-1
           xor eax,eax
           mov ax,offset idt
           add eax,ebp
           mov dword ptr pdescr+2,eax
           lidt pdescr

; ***************     ****************

           mov  eax,cr0	;   CR0
           or   eax,1	;   PE 
           mov  cr0,eax	; 

;  CS:IP    
           db   0eah		;   far jmp
           dw   offset continue ;  IP     
           dw   16		;   
     continue:

           mov  ax,8  ;      
           mov  ds,ax ; :    
           mov  ax,24 ;  
           mov  ss,ax
           mov  ax,32
           mov  es,ax
	   mov  sp,1024

           ;***
           mov  ax,40;  TR
           ltr  ax   ;   0-   
		     ;  
;*********************************************************************
;    - 
;        
; .   , ,  
;   
sti
          d1:    mov    ah,57h
                 mov    cx,2
          d2:    push   cx
                 mov    di,1280
                 mov    cx,mes0_len
                 mov    si,offset mes0
                 cld
          d3:    lodsb
                 stosw
                 loop   d3
                 delay  30
                 pop    cx
                 mov    ah,67h
                 loop   d2
                 jmp    d1
;*********************************************************************         
;  
home:    mov  si,offset  string
	 debug
	 mov	si,offset string
	 mov	cx,len
	 mov	ah,74h
	 mov	di,1740
  scr:   lodsb
	 stosw
	 loop  scr

;    ,     
;        

       return:   
  		 mov  ax,data
                 mov  ds,ax
		 mov ax,0 ;     2    
		 mov  gs,ax;     gs!!!!!!
			;    ,    
			;     
			;   10- TSS
                 mov  ax,stk
                 mov  ss,ax
                 mov  sp,stk386;256
                 sti
 ;       
                mov  al,0b8h
                out  21h,al
                mov  al,9dh
                out  0a1h,al
 ;    DOS   
                mov  ah,09h
                mov  dx,offset  mes
                int  21h
 ;     DOS
                mov  ax,4c00h
                int  21h
       main  endp
;*********************************************************************
;    
;*********************************************************************
     code_size=$-begin
     text  ends

stk386=400h ;    
stk0=200h
;*********************************************************************
		;    
;*********************************************************************

     stk segment stack 'stack'
     db   stk386   dup ('^');
     stk ends

;*********************************************************************
		;C   1
;*********************************************************************

     data_1    segment  use16
     data_1_beg=$
     mes1        db     22,22,22,'  Task_1  3',22,22,22
     mes1_len=$-mes1
     data_1_size=$-data_1_beg
     data_1  ends

;*********************************************************************
		;C   1
;*********************************************************************

     text_1   segment  'code'  use16
                assume cs:text_1;ds:data_1
;     ,    0,  
;  
       task1    proc
           a1:  mov     ah,71h
                mov     cx,5
           a2:  push    cx
                mov     di,800
                mov     cx,mes1_len
                mov     si,offset  mes1
                cld
           a3:  lodsb
                stosw
                loop    a3
                delay   100
                pop     cx
                mov     ah,17h
                loop    a2
                jmp     a1
           task1 endp
       code_1_size=$-task1
       text_1  ends

;*********************************************************************
		;C   1
;*********************************************************************

       stk_1  segment 'stack'
       db  256  dup ('^')
       stk_1 ends

;*********************************************************************
		;C   2
;*********************************************************************

      data_2    segment  use16
     data_2_beg=$
     mes2        db     22,22,22,'  Task_2  3',22,22,22
     mes2_len=$-mes2
     data_2_size=$-data_2_beg
     data_2  ends

;*********************************************************************
		;C   2
;*********************************************************************

     text_2   segment  'code'  use16
                assume cs:text_2;ds:data_2
;     ,    0,  
;  
task2 proc
          b1:    mov    ah,34h
                 mov    cx,2
          b2:    push   cx
                 mov    di,1120
                 mov    cx,mes2_len
                 mov    si,offset mes2
                 cld
          b3:    lodsb
                 stosw
                 loop   b3
                 delay  30
                 pop    cx
                 mov    ah,43h
                 loop   b2
                 jmp    b1
          task2    endp
        code_2_size=$-task2
       text_2  ends

;*********************************************************************
		;C   2
;*********************************************************************

       stk_2  segment  'stack'
       db    256  dup ('^')
       stk_2   ends

;*********************************************************************
		;C    V86
;*********************************************************************

       data_86  segment   'abc'  use16
       mes_86   db      4,4,4,'    8086',4,4,4
       mes_86_len=$-mes_86
	mes_00  db   3,3,3,'  ',3,3,3
	mes_00_len=$-mes_00
       data_86_size=$-mes_86
       data_86 ends

;*********************************************************************
		;C    V86
;*********************************************************************

       code_86   segment  'abc' use16
                 assume  cs:code_86,ds:data_86;?????????
;     ,    0,  
;  

         task_v86    proc
          c1:    mov    ah,31h
                 mov    cx,2
          c2:    push   cx
		 mov 	di,1020
                 mov    cx,mes_86_len
                 mov    si,offset mes_86
                 cld
          c3:    lodsb
                 stosw
                 loop   c3
		 delay 30
                 pop    cx		
                 mov    ah,41h     
                 loop   c2
;      ,    BIOS 
; INT 10h
	mov cx,mes_00_len
	mov bx,offset mes_00
	mov ah,0eh
wr:	mov al,[bx]
	inc bx
	int 10h
	loop wr
                 jmp    c1;     

           task_v86  endp

         code_86_size=$-task_v86
         code_86 ends
stk86=200h
;*********************************************************************
		;C    V86
;*********************************************************************

         stk_86   segment 'abc'
                  db    stk86  dup ('0')
	stk_86_size=$-stk_86
           stk_86  ends
              end   main
;*********************************************************************
		; 
;*********************************************************************